<?xml version="1.0" encoding="GBK"?>
<!-- version="V3.7.1.8" -->
<application name="msg_client" redirect="y">
    <mainsvr stop_sequence="ospf">
        <plugins>
            <plugin lib="fsc_f2log" getinfo="GetLogServiceInfo" load_level="1" note="日志">
                <args cfgfile="log.xml" default_level="3"/>
            </plugin>
            <plugin lib="fsc_f2mproxy" getinfo="GetMProxyInfo" load_level="1" note="管理代理"/>
            <plugin lib="fsc_f2ospf" getinfo="GetOSPFInfo" load_level="1" note="OSPF"/>
            <plugin lib="fsc_filter_log" getinfo="GetFilterLogInfo" load_level="1" note="抓包器">
                <args start="n"/>
            </plugin>
            <plugin lib="fsc_f2pack" getinfo="GetPackSvrInfo" load_level="0">
                <args v1_count="600" v2_count="600"/>
            </plugin>
            <plugin lib="fsc_esbmsg" getinfo="GetESBMessageFactoryInfo" load_level="0" note="ESB消息工厂插件">
                <args msgs_pool_number="8" init_msgs_inpool="10000" max_msgs_inapp="16000" max_msgs_inpool="10000"/>
            </plugin>
            <plugin lib="fsc_f2config" getinfo="GetCfgSvrInfo" load_level="0" note="配置服务"/>
            <plugin lib="fsc_f2security" getinfo="GetSecurityInfo" load_level="1" note="安全服务"/>
            <plugin lib="fsc_msgcenter" getinfo="GetMsgCenterInfo" load_level="1" note="消息中心">
                <args thread_num="4" heartbeatinterval="30" heartbeattimeoutnum="10" loglevel="50" outputdest="2" logfilename="mc" max_queue_num="10000"/>
                <inspect destip="127.0.0.1" destport="18888" udpsendinterval="60"/>
                <issuetype note="允许发布类型">
                    <!--行情相关配置-->
                    <type value="16" superior="0" note="期货单腿行情订阅">
                        <key name="contract_code"/>
                    </type>
                    <type value="22" superior="0" note="期货行情订阅">
                        <key name="contract_code"/>
                    </type>
                    <type value="33100" superior="0" note="期货行情订阅">
                        <key name="contract_code"/>
                    </type>
                    <!--组合行情相关配置-->
                    <type value="18" superior="0" note="期货组合行情订阅">
                        <key name="arbicontract_id"/>
                    </type>
                    <type value="33102" superior="0" note="期货组合行情订阅">
                        <key name="arbicontract_id"/>
                    </type>
                    <!--回报相关配置-->
                    <type value="17" superior="0" note="期货反馈订阅">
                        <key name="branch_no"/>
                        <key name="fund_account"/>
                    </type>
                    <type value="23" superior="0" note="期货反馈订阅">
                        <key name="branch_no"/>
                        <key name="fund_account"/>
                    </type>
                    <type value="33101" superior="0" note="期货反馈订阅">
                        <key name="branch_no"/>
                        <key name="fund_account"/>
                    </type>
                    <!--交易所状态相关配置-->
                    <type value="24" superior="0" note="期货组合交易所状态">
                        <key name="futu_exch_type"/>
                    </type>
                    <type value="33105" superior="0" note="期货组合交易所状态">
                        <key name="futu_exch_type"/>
                    </type>
                    <!--客户端在线消息-->
                    <type value="19" superior="0" note="客户端在线消息">
                        <key name="branch_no"/>
                        <key name="fund_account"/>
                    </type>
                    <!--期货询价通知-->
                    <type value="33300" superior="0" note="期货询价通知">
                        <key name="contract_code"/>
                    </type>
                    <!--期货报价回报-->
                    <type value="33301" superior="0" note="期货报价回报">
                        <key name="branch_no"/>
                        <key name="fund_account"/>
                    </type>
                    <!--期权执行流水回报-->
                    <type value="33110" superior="0" note="期权执行流水回报">
                        <key name="branch_no"/>
                        <key name="fund_account"/>
                    </type>
                    <!--条件单相关配置-->
                    <type value="21" superior="0" note="条件单主推消息">
                        <key name="branch_no"/>
                        <key name="fund_account"/>
                    </type>
                    <type value="33111" superior="0" note="策略单状态信息">
                        <key name="branch_no"/>
                        <key name="fund_account"/>
                    </type>
                    <type value="33117" superior="0" note="期权对冲设置通知">
                        <key name="fund_account"/>
                    </type>
					<type value="33106" superior="0" note="组合保证金确认">
                        <key name="fund_account"/>
                    </type>
                </issuetype>
                <subsciberequest note="主动向上级消息中心发起的订阅请求">
                    <!--向上级订阅22类型的行情-->
                    <request issuetype="22" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅期货行情消息">
                        <param name="contract_code" value="*"/>
                    </request>
                    <!--向上级订阅组合行情-->
                    <request issuetype="18" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅期货组合消息">
                        <param name="arbicontract_id" value="*"/>
                    </request>
                    <!--向上级订阅33101回报-->
                    <request issuetype="33101" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅期货反馈消息">
                        <param name="branch_no" value="*"/>
                        <param name="fund_account" value="*"/>
                    </request>
                    <!--向上级订阅交易所状态-->
                    <request issuetype="24" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅期货交易所状态">
                        <param name="futu_exch_type" value="*"/>
                    </request>
                    <!--向上级订阅客户端在线消息-->
                    <request issuetype="19" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅客户端在线消息">
                        <param name="branch_no" value="*"/>
                        <param name="fund_account" value="*"/>
                    </request>
                    <!--向上级订阅期货询价通知-->
                    <request issuetype="33300" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="期货询价通知">
                        <param name="contract_code" value="*"/>
                    </request>
                    <!--向上级订阅期货报价回报-->
                    <request issuetype="33301" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="期货报价回报">
                        <param name="branch_no" value="*"/>
                        <param name="fund_account" value="*"/>
                    </request>
                    <!--向上级订阅期权执行流水回报-->
                    <request issuetype="33110" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="期权执行流水回报">
                        <param name="branch_no" value="*"/>
                        <param name="fund_account" value="*"/>
                    </request>
                    <!--条件单相关配置-->
                    <request issuetype="21" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅条件单主推消息">
                        <param name="branch_no" value="*"/>
                        <param name="fund_account" value="*"/>
                    </request>
                    <request issuetype="33111" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="策略单状态信息">
                        <param name="branch_no" value="*"/>
                        <param name="fund_account" value="*"/>
                    </request>
                    <request issuetype="33117" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="期权对冲设置通知">
                        <param name="fund_account" value="*"/>
                    </request>
					<request issuetype="33106" functionno="620001" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="msgcenter" note="组合保证金确认">
                        <param name="fund_account" value="*"/>
                    </request>
                </subsciberequest>
            </plugin>
            <plugin lib="fsc_futuhq" getinfo="GetFUTUHQInfo" load_level="2" note="期货行情">
                <args enableudprecv="0" heartbeattimeout="30" port="0" subscibetomc="1" inittime="180000" sysversion="0"/>
                <mc>
                    <!--向本地消息中心订阅22类型的行情，用于更新缓存和转换-->
                    <request issuetype="22" functionno="620001" ospfname="msg_client#0" svrname="mainsvr#-1" pluginid="msgcenter" note="向消息中心订阅单腿行情">
                        <param name="contract_code" value="*"/>
                    </request>
                    <!--向本地消息中心订阅18组合行情，用于更新缓存和转换-->
                    <request issuetype="18" functionno="620001" ospfname="msg_client#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅组合行情">
                        <param name="arbicontract_id" value="*"/>
                    </request>
                    <!--向本地消息中心订阅16类型的行情，用于更新缓存和转换-->
                    <request issuetype="16" functionno="620001" ospfname="msg_client#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅单脚行情" value="123">
                        <param name="contract_code" value="*"/>
                    </request>
                    <!--向本地消息中心订阅24交易所状态，用于更新缓存和转换-->
                    <request issuetype="24" functionno="620001" ospfname="msg_client#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅交易所状态">
                        <param name="futu_exch_type" value="*"/>
                    </request>
                    <!--向本地消息中心订阅33101，用于本地转换成17和23-->
                    <request issuetype="33101" functionno="620001" ospfname="msg_client#0" svrname="mainsvr#-1" pluginid="msgcenter" note="订阅33101回报">
                        <param name="branch_no" value="*"/>
                        <param name="fund_account" value="*"/>
                    </request>
                    <!--向上级同步单腿行情，用于启动时将上级消息中心的单腿行情缓存同步到本地-->
                    <request issuetype="0" functionno="620202" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="futuhq" note="向上级同步单腿行情">
                        <param name="contract_code" value="*"/>
                    </request>
                    <!--向上级同步单腿扩展行情，用于启动时将上级消息中心的单腿行情缓存同步到本地-->
                    <request issuetype="0" functionno="620204" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="futuhq" note="向上级同步单腿行情">
                        <param name="contract_code" value="*"/>
                    </request>
                    <!--向上级同步组合行情，用于启动时将上级消息中心的组合行情缓存同步到本地-->
                    <request issuetype="0" functionno="620203" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="futuhq" note="向上级同步组合行情">
                        <param name="arbicontract_id" value="*"/>
                    </request>
                    <!--向上级同步交易所状态，用于启动时将上级消息中心的交易所状态缓存同步到本地-->
                    <request issuetype="0" functionno="620206" ospfname="msg_main#0" svrname="mainsvr#-1" pluginid="futuhq" note="向上级同步交易所状态">
                        <param name="futu_exch_type" value="*"/>
                    </request>
                </mc>
                <convert>
                    <!--22转换为16-->
                    <convert22to16>1</convert22to16>
                    <!--22转换为33100-->
                    <convert22to33100>1</convert22to33100>
                    <!--33101转换为17-->
                    <convert33101to17>1</convert33101to17>
                    <!--33101转换为23-->
                    <convert33101to23>1</convert33101to23>
                    <!--18转换为33102-->
                    <convert18to33102>1</convert18to33102>
                    <!--24转换为33105-->
                    <convert24to33105>1</convert24to33105>
                </convert>
            </plugin>
            <plugin lib="fsc_router" getinfo="GetRouterInfo" load_level="1" note="路由">
                <args thread_num="8"/>
                <routes>
                    <routetable functionid="8" pluginid="mproxy"/>
                    <!--338330路由给断点续传使用，06不支持断点续传，该路由不用配置-->
                    <!--routetable functionid="338330"  branchno="*;" nodename="ufx_10_06" truncation="0"/-->
                    <routetable functionid="62020?;" branchno="*;" pluginid="futuhq"/>
                    <routetable functionid="620???;" branchno="*;" pluginid="msgcenter"/>
                    <routetable functionid="*;" branchno="*;" nodename="msg_main"/>
                </routes>
                <defaultgateway/>
            </plugin>
            <plugin lib="fsc_channel_t2" getinfo="GetT2ChannelInfo" note="t2通道_外网">
                <config>
                    <safe safe_level="none" server_type="futu_hq" default_comm_key=""/>
                    <ssl cert_file="" cert_pwd=""/>
                    <network protocol="tcp" address="" port="9301"/>
                    <performance thread_count="3" max_connection="10000" init_connection="50" init_recv_buf_size="1024" init_send_buf_size="1024" send_queue_size="10000"/>
                    <limit license_dir="license" register_time="5" heartbeat_time="60" check_ordinal="1" forbidadmin="1"/>
                </config>
            </plugin>
            <plugin lib="fsc_channel_t2" getinfo="GetT2ChannelInfo" note="t2#1通道_内网" instance="1">
                <config>
                    <safe safe_level="none" server_type="futu_hq" default_comm_key=""/>
                    <ssl cert_file="" cert_pwd=""/>
                    <network protocol="tcp" address="" port="9302"/>
                    <performance thread_count="3" max_connection="10000" init_connection="50" init_recv_buf_size="1024" init_send_buf_size="1024" send_queue_size="10000"/>
                    <limit license_dir="license" register_time="5" heartbeat_time="60" check_ordinal="1"/>
                </config>
            </plugin>
            <plugin lib="fsc_channel_f2" getinfo="GetF2ChannelInfo" load_level="1" note="f2通道">
                <args port="18516" safetype="0" comm_thread_num="4"/>
                <parents>
                    <parent parentname="msg_main"/>
                    <!--338330路由给断点续传使用，06不支持断点续传，该路由不用配置-->
                    <!--parent parentname="ufx_10_06"/-->
                </parents>
            </plugin>
            <plugin lib="fsc_bizcontrol_core" getinfo="GetBizControlInfo" load_level="1" note="业务控制插件">
                <args template=""/>
                <biz>
                    <lib name="CheckIssue" note="订阅回报校验密码"/>
                </biz>
                <params>
                    <thread_num>8</thread_num>
                    <debug_level>0</debug_level>
                    <heartbeat>10</heartbeat>
                </params>
            </plugin>
            <plugin lib="fsc_pipe_mgr" is_inter="1" note="消息流水线配置">
                <pipe>ospf;router</pipe>
                <pipe>mproxy;router</pipe>
                <pipe>msgcenter;filter_log;router</pipe>
                <pipe>futuhq;filter_log;router</pipe>
                <pipe>t2;bizcontrol_core;router</pipe>
                <pipe>t2#1;filter_log;router</pipe>
                <pipe>f2;bizcontrol_core;router</pipe>
            </plugin>
        </plugins>
    </mainsvr>
</application>
